<?php

/**
 * This project has been generated by nuts generator
 * nuts has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 */


namespace Model;

use Base\BaseModel;
use Handler\DataValidationException;

class TransactionModel extends BaseModel
{
    protected $table = "transaction";

    protected $aliasTable = "trans";

    protected $primaryKey = "id";
    protected $fillable = ["amount", "createdAt", "description", "familyid", "paymentType", "postedDate", "referenceNumber", "transactionType", "updatedAt"];

    public function joinRelationFamily($alias = "family")
    {
        $this->query->join("family as $alias", "$alias.id", "=", "trans.familyid");
        return $this;
    }


    public function beforeEnterIntoDatabase()
    {
        if (empty($this->amount)) {
            throw new DataValidationException("amount cannot be null");
        }
        if (empty($this->familyid)) {
            throw new DataValidationException("familyid cannot be null");
        }
        if (empty($this->paymentType)) {
            throw new DataValidationException("paymentType cannot be null");
        }
        if (empty($this->postedDate)) {
            throw new DataValidationException("postedDate cannot be null");
        }
        $Family = (new \Model\FamilyModel)->findById($this->familyid);
        if (empty($Family)) {
            throw new DataValidationException("familyid Invalid Relation ID");
        }
        return $this;
    }
}